package cordova.plugin.netcontroll.integration.tef;

import org.apache.cordova.CordovaPlugin;
import org.apache.cordova.CallbackContext;
import org.apache.cordova.CordovaInterface;
import org.apache.cordova.CordovaWebView;

import org.json.JSONArray;
import org.json.JSONException;

import android.app.Activity;
import android.content.Context;

public class NetControllCordovaPluginsIntegrationTef extends CordovaPlugin {
    //Tef
    public TefElgin tefElgin;

    //Cordova/Java Params
    private Activity mActivity;
    private Context mContext;
    private CordovaInterface mCordova;
    private CordovaWebView webView;

    @Override
    public void initialize(CordovaInterface cordova, CordovaWebView webView) {
        super.initialize(cordova, webView);

        this.webView = webView;
        mActivity = cordova.getActivity();
        mContext = cordova.getActivity().getApplicationContext();
        mCordova = cordova;
    }

    private void initializeTefElgin() {
        if (this.tefElgin == null) {
            this.tefElgin = new TefElgin();
            this.tefElgin.initialize(this.cordova, this.webView);
        }
    }

    @Override
    public boolean execute(String action, JSONArray args, CallbackContext callbackContext) throws JSONException {
        try {
            String result = "Sem resultado";
            String[] actionProviderList = action.split("\\.");
            String provider = actionProviderList[0];

            switch (provider.toLowerCase()) {
                case "tef":
                    String tefProduct = actionProviderList[1];
                    switch (tefProduct.toLowerCase()) {
                        case "elgin":
                            this.initializeTefElgin();
                            String tefSuminAction = actionProviderList[2];
                            boolean resultTefSuminExecute = this.tefElgin.execute(tefSuminAction, args, callbackContext);
                            return resultTefSuminExecute;
                        default:
                            break;
                    }
                default:
                    break;
            }
            callbackContext.success(result);
            return true;
        } catch (Exception e) {
            callbackContext.error("NetControllCordovaPluginsIntegrationTef excute error: " + e.toString());
        }
        return false;
    }
}
