package cordova.plugin.netcontroll.integration.tef;

// import cordova.plugin.netcontroll.integration.tef.TefElginHelpers;

import org.apache.cordova.CordovaPlugin;
import org.apache.cordova.CallbackContext;
import org.apache.cordova.CordovaInterface;
import org.apache.cordova.CordovaWebView;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;


import android.graphics.Bitmap;
import android.os.AsyncTask;

import com.google.gson.JsonObject;
import com.google.gson.JsonParser;
import com.google.zxing.EncodeHintType;
import com.google.zxing.MultiFormatWriter;
import com.google.zxing.qrcode.decoder.ErrorCorrectionLevel;
import com.izettle.html2bitmap.Html2Bitmap;
import com.izettle.html2bitmap.content.WebViewContent;


// import androidx.annotation.NonNull;
// import androidx.annotation.NonNull;

import android.app.Activity;
import android.graphics.Bitmap;
import android.content.Context;
import android.os.Handler;
import android.os.Looper;
import android.os.Message;
import android.util.Log;
import android.widget.Toast;
import android.net.Uri;
import android.content.Intent;
import android.provider.MediaStore;
import android.os.Build;

import static android.app.Activity.RESULT_OK;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.EnumMap;
import java.util.HashMap;
import java.util.Map;

import javax.security.auth.callback.Callback;

import java.util.List;

//Json Serialize
import com.google.gson.Gson;
import com.google.gson.GsonBuilder;


//Bitmap
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Matrix;

import android.util.Base64;

import androidx.annotation.NonNull;

import java.io.ByteArrayOutputStream;
import java.util.Objects;
import java.util.stream.Collectors;

import com.google.zxing.BarcodeFormat;
import com.google.zxing.WriterException;
import com.google.zxing.qrcode.QRCodeWriter;
import com.google.zxing.common.BitMatrix;


//Tef Elgin
import com.elgin.e1.core.configure.TefConfigure;
import com.elgin.e1.pagamentos.tef.E1_ElginTef;

import cordova.plugin.netcontroll.integration.tef.helpers.TefElginHelper_E1ElginTef;


public class TefElgin {
    // private BaseTransactionProvider transactionProvider;
    // private E1_ElginTef E1ElginTef;
    private cordova.plugin.netcontroll.integration.tef.helpers.TefElginHelper_E1ElginTef TefElginHelper;

    //Cordova/Java Params
    private Activity mActivity;
    private Context mContext;
    private CordovaWebView webView;

    public void initialize(CordovaInterface cordova, CordovaWebView webView) {
        this.webView = webView;
        mActivity = cordova.getActivity();
        mContext = this.webView.getContext();


        //Elgin
        // this.E1ElginTef = new E1_ElginTef(mContext);
        this.TefElginHelper = new cordova.plugin.netcontroll.integration.tef.helpers.TefElginHelper_E1ElginTef(mContext);
    }

    public boolean execute(String action, JSONArray args, CallbackContext callbackContext) throws JSONException {
        if (action.equals("Testar")) {
            callbackContext.success("Testado");
            return true;
        }
        if (action.equals("InformarDadosAutomacao")) {
            JSONObject params = args.getJSONObject(0);
            try {
                String nomeAc = params.getString("nomeAc");
                String versaoAc = params.getString("versaoAc");
                String textoPinPad = params.getString("textoPinPad");
                String macPinPad = params.getString("macPinPad");
                String acProducao = params.getString("acProducao");
                boolean resultInformacao = TefElginHelper.informarDadosAutomacao(nomeAc, versaoAc, textoPinPad, macPinPad, acProducao);
                if (resultInformacao) {
                    callbackContext.success("Informações adicionadas com sucesso");
                } else {
                    callbackContext.error("Falha ao adicionar informações automação");
                }
                return true;
            } catch (Exception error1) {
                callbackContext.error(error1.toString());
            }
            return false;
        } else if (action.equals("AtivarTerminal")) {
            JSONObject params = args.getJSONObject(0);
            try {
                String cnpj = params.getString("cnpj");
                String statusChangeCallBack = params.getString("statusChangeCallBack");

                Handler ativarTerminalHandler = new Handler(Looper.getMainLooper()) {
                    @Override
                    public void handleMessage(@NonNull Message msg) {
                        super.handleMessage(msg);
                        if (msg.what == 0) {
                            String saida = (String) msg.obj;
                            callbackContext.success(saida);
                        } else {
                            callbackContext.error(msg.obj.toString());
                        }
                    }
                };
                this.TefElginHelper.ativarTerminal(cnpj, ativarTerminalHandler, new TefElginHelper_E1ElginTef.TefElginHelper_E1ElginTef_ActionCallback() {
                    @Override
                    public void onStatusChanged(String message) {
                        executeGlobalJavascript(statusChangeCallBack + "('" + message + "')");
                    }
                });
                return true;
            } catch (Exception error1) {
                callbackContext.error(error1.toString());
            }
            return false;
        } else if (action.equals("IniciarVenda")) {
            JSONObject params = args.getJSONObject(0);
            try {
                int tipoTransacao = params.getInt("tipoTransacao");
                String valorTransacao = "0";
                if (tipoTransacao >= 0) {
                    valorTransacao = params.getString("valorTransacao");
                }
                String statusChangeCallBack = params.getString("statusChangeCallBack");

                Handler transacaoHandler = new Handler(Looper.getMainLooper()) {
                    @Override
                    public void handleMessage(@NonNull Message msg) {
                        super.handleMessage(msg);
                        if (msg.what == 0) {
                            String saida = (String) msg.obj;
                            JsonObject convertedObject = new JsonParser().parse(saida).getAsJsonObject();
                            mActivity.runOnUiThread(new Runnable() {
                                @Override
                                public void run() {
                                    executeGlobalJavascript(statusChangeCallBack + "('" + convertedObject.get("mensagem") + "')");
                                }
                            });
                            callbackContext.success(saida);
                        } else {
                            callbackContext.error(msg.obj.toString());
                        }
                    }
                };

                switch (tipoTransacao) {
                    case 0: //Debito
                        this.TefElginHelper.iniciarVendaDebito(valorTransacao, transacaoHandler, new TefElginHelper_E1ElginTef.TefElginHelper_E1ElginTef_ActionCallback() {
                            @Override
                            public void onStatusChanged(String message) {
                                executeGlobalJavascript(statusChangeCallBack + "('" + message + "')");
                            }
                        });
                        break;
                    case 1: //Credito
                        int parcelas = params.getInt("parcelas");
                        int financiamento = params.getInt("financiamento");
                        this.TefElginHelper.iniciarVendaCredito(valorTransacao, parcelas, financiamento, transacaoHandler, new TefElginHelper_E1ElginTef.TefElginHelper_E1ElginTef_ActionCallback() {
                            @Override
                            public void onStatusChanged(String message) {
                                executeGlobalJavascript(statusChangeCallBack + "('" + message + "')");
                            }
                        });
                        break;
                    case -1: //Default
                        callbackContext.error("Tipo transação inválida");
                        return false;
                }
                return true;
            } catch (Exception error1) {
                callbackContext.error(error1.toString());
            }
            return false;
        } else if (action.equals("IniciarCancelamento")) {
            JSONObject params = args.getJSONObject(0);
            try {
                String valorTransacao = params.getString("valorTransacao");
                String nsuTransacao = params.getString("nsuTransacao");
                String dataTransacao = params.getString("dataTransacao");
                String statusChangeCallBack = params.getString("statusChangeCallBack");

                Handler transacaoCancelamentoHandler = new Handler(Looper.getMainLooper()) {
                    @Override
                    public void handleMessage(@NonNull Message msg) {
                        super.handleMessage(msg);
                        if (msg.what == 0) {
                            String saida = (String) msg.obj;
                            JsonObject convertedObject = new JsonParser().parse(saida).getAsJsonObject();
                            mActivity.runOnUiThread(new Runnable() {
                                @Override
                                public void run() {
                                    executeGlobalJavascript(statusChangeCallBack + "('" + convertedObject.get("mensagem") + "')");
                                }
                            });
                            callbackContext.success(saida);
                        } else {
                            callbackContext.error(msg.obj.toString());
                        }
                    }
                };
                this.TefElginHelper.iniciarCancelamento(valorTransacao, nsuTransacao, dataTransacao, transacaoCancelamentoHandler, new TefElginHelper_E1ElginTef.TefElginHelper_E1ElginTef_ActionCallback() {
                    @Override
                    public void onStatusChanged(String message) {
                        executeGlobalJavascript(statusChangeCallBack + "('" + message + "')");
                    }
                });
                return true;
            } catch (Exception error1) {
                callbackContext.error(error1.toString());
            }
            return false;
        } else if (action.equals("AbortarOperacao")) {
            JSONObject params = args.getJSONObject(0);
            try {
                this.TefElginHelper.realizarCancelamentoOperacao();
                callbackContext.success();
                return true;
            } catch (Exception error1) {
                callbackContext.error(error1.toString());
            }
            return false;

        }
        return true;
    }

    private void executeGlobalJavascript(final String jsString) {
        mActivity.runOnUiThread(new Runnable() {
            @Override
            public void run() {
                webView.loadUrl("javascript:" + jsString);
            }
        });
    }

}
